/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: AbstractRulePackageMemberVO.as 4798 2009-08-07 12:30:47Z alitokmen $
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.rules.common.vo.rulepackage
{

import flash.events.Event;
import flash.events.EventDispatcher;

import mx.events.PropertyChangeEvent;
import mx.events.PropertyChangeEventKind;

/**
* The base mechanism for any part of a rule package of any kind, even
* the whole package itself
*
* @author Julien Nicoulaud
*/
[RemoteClass(alias="org.ow2.jasmine.rules.manager.model.AbstractRulePackageMember")]
public class AbstractRulePackageMemberVO extends EventDispatcher
                                         implements IRulePackageMember
{
    
    // =========================================================================
    // Utils
    // =========================================================================
    
    /**
    * Get the generated source in Drools syntax
    */    
    public function getDrlSource():String
    {
        throw new Error("The method getDrlSource () of the interface " + 
                        "IRulePackageMember is not implemented.");
    }
    
    /**
    * Helper function to dispatch an property event
    */
    protected function notifyPropertyChange(property:String,
                                            oldValue:Object,
                                            value:Object):void
    {
        dispatchEvent(PropertyChangeEvent.createUpdateEvent(this,property,oldValue,value));
    }
    
}
}
